using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FF3LE
{
    public partial class ReaedRomSetting : Form
    {
        public ReaedRomSetting()
        {
            InitializeComponent();
        }
        #region stringTable
        public string[] dialogueTable = new string[]
            {
                "/", "*", "TERRA", "LOCKE", "CYAN", "SHADOW", "EDGAR", "SABIN", 
                "CELES", "STRAGO", "RELM", "SETZER", "MOG", "GAU", "GOGO", "UMARO", 
                "", "", "", "*", "", "", "", "", 
                "", "", "", "", "", "", "", "", 
                "A", "B", "C", "D", "E", "F", "G", "H",
                "I", "J", "K", "L", "M", "N", "O", "P", 
                "Q", "R", "S", "T", "U", "V", "W", "X", 
                "Y", "Z", "a", "b", "c", "d", "e", "f", 
                "g", "h", "i", "j", "k", "l", "m", "n",
                "o", "p", "q", "r", "s", "t", "u", "v", 
                "w", "x", "y", "z", "0", "1", "2", "3",
                "4", "5", "6", "7", "8", "9", "!", "?", 
                "", ":", "\"", "'", "-", ".", ",", "...",
                ";", "#", "+", "(", ")", "%", "~", "", 
                "@", "<note>", "=", "\"", "74", "75", "<pearl>", "<death>",
                "<lit>", "<wind>", "<earth>", "<ice>", "<fire>", "<water>", "<poison>", " ", 
                "e ", " t", ": ", "th", "t ", "he", "s ", "er", 
                " a", "re", "in", "ou", "d ", " w", " s", "an", 
                "o ", " h", " o", "r ", "n ", "at", "to", " i",
                ", ", "ve", "ng", "ha", " m", "Th", "st", "on", 
                "yo", " b", "me", "y ", "en", "it", "ar", "ll",
                "ea", "I ", "ed", " f", " y", "hi", "is", "es", 
                "or", "l ", " c", "ne", "'s", "nd", "le", "se", 
                " I", "a ", "te", " l", "pe", "as", "ur", "u ", 
                "al", " p", "g ", "om", " d", "f ", " g", "ow",
                "rs", "be", "ro", "us", "ri", "wa", "we", "Wh", 
                "et", " r", "nt", "m ", "ma", "I'", "li", "ho",
                "of", "Yo", "h ", " n", "ee", "de", "so", "gh", 
                "ca", "ra", "n'", "ta", "ut", "el", "! ", "fo",
                "ti", "We", "lo", "e!", "ld", "no", "ac", "ce", 
                "k ", " u", "oo", "ke", "ay", "w ", "!!", "ag",
                "il", "ly", "co", ". ", "ch", "go", "ge", "e..."
            };
        public string[] nameTable = new string[]
            {
                "<EBhE؂ւ>\r\n","\r\n","è","ۯ","","޳","޶ް","ϯ",
                //"<EBhE؂ւ>\r\n","<s>\r\n","è","ۯ","","޳","޶ް","ϯ",
                @"ؽ","׺޽","","§","Ӹ","޳","޺","",

                "<Wait֘A1>","<I֘A?0x11>","<IR[h?0x12>","<Wait֘A2>","<R[h?0x14>","<I>",
                  "<Wait֘A3>","<gp0x17>","<R[h?0x18>","<gp0x19>","<gp0x1A>",
                @"<g1B>","<g1C>","<g1D>","<g1E>","<g1F>",

                "o","","r","","u","","x","","{","","K","","M","","O","",
                "Q","","S","","U","","W","","Y","","[","","]","","_","",
                "a","","d","","f","","h","","","p","","s","","v","","y",
                "","|","","O","P","Q","R","S","T","U","V","W","X","M","H","P",
                "n","","q","","t","","w","","z","","J","","L","","N","",
                "P","","R","","T","","V","","X","","Z","","\","","^","",
                "`","","c","","e","","g","","E","","A","","C","","G","",
                "I","","i","","j","","k","","l","","m","","}","","~","",
                "","","","","","","","","","","","","","","","",
                "","","","","","","","","","","","","b","","","",
                "","","","","@","[","B","c","D","!" ,"F","?" ,"H","A","/" ," :",

                "u","v","B","{","","","<I>","~","cc","鍑","","","b","Ȃ","","E",
                "Ă","޽ׁu","̶u","","","","݁u","","m","ł",
                @"ށu","̗","","B","B","l",
                "eBi","bN","JCG","VhE","GhK[","}bV","ZX","XgSX",
                @"","Zbc@[","O","KE","SS","E[}","<gp?0xFE>","@",
            };
        private string[] kanjiTable1B = new string[]
            {
                "","","","","","i","","R","","","","","","L","Z","",
                "","M","_","J","S","t","g","U","C","","","","l","n","U","D",
                "J","","v","","","","h","","P","","","","","","r","n",
                "~","","j","","","","","","","x","","","G","K","","U",
                "G","R","","]","","b","r","","k","","","A","","","","Q",
                "","","","@","D","","","","s","","T","5B","5C","5D","5E","5F",
                "60","61","62","63","64","65","66","67","68","69","6A","6B","6C","6D","6E","6F",
                "70","71","72","73","74","75","76","77","78","79","7A","7B","7C","7D","7E","7F",
                "80","81","82","83","84","85","86","87","88","89","8A","8B","8C","8D","8E","8F",
                "90","91","92","93","94","95","96","97","98","99","9A","9B","9C","9D","9E","9F",
                "A0","A1","A2","A3","A4","A5","A6","A7","A8","A9","AA","AB","AC","AD","AE","AF",
                "B0","B1","B2","B3","B4","B5","B6","B7","B8","B9","BA","BB","BC","BD","BE","BF",
                "C0","C1","C2","C3","C4","C5","C6","C7","C8","C9","CA","CB","CC","CD","CE","CF",
                "D0","D1","D2","D3","D4","D5","D6","D7","D8","D9","DA","DB","DC","DD","DE","DF",
                "E0","E1","E2","E3","E4","E5","E6","E7","E8","E9","EA","EB","EC","ED","EE","EF",
                "F0","F1","F2","F3","F4","F5","F6","F7","F8","F9","FA","FB","FC","FD","FE","FF",
            };
        private string[] kanjiTable1C = new string[]
            {
                "","","","","","","","q","","","t","","p","Q","","",
                "v","R","","m","","l","","b","","","","","","","V","",
                "","","{","","","","N","","","","","z","","x","","J",
                "","","","","","j","","","","","D","","","N","c","",
                "O","`","M","","","l","F","","@","k","A","","e","D","","",
                "N","","","","","","","","X","","","Z","","","Z","",
                "a","","","n","","","","","","M","","","","","^","",
                "","","y","a","R","","s","~","","v","","","","","","",
                "","]","","g","","","","","x","","","","K","t","","s",
                "","","","B","","","","","","I","","H","v","","","",
                "D","`","","","","","x","}","","","","","","i","","",
                "X","","R","","","t","","\","p","t","h","","v","","","",
                "I","","","","","","Y","","","","R","A","","","","",
                "","","","","","K","~","","I","","i","","","","","",
                "Y","","q","","V","","","","W","","","","","","","`",
                "","","","v","","W","N","","","","B","L","","L","","",
            };
        private string[] kanjiTable1D = new string[]
            {
                "","","b","","p","@","","","","Q","","","","t","","",
                "","","","G","","E","","","","D","","k","","","","",
                "","","\","y","","","i","","S","","p","[","","","","",
                "X","","","","","","","","","","","","","","","",
                "","","","","","","","i","","","Y","~","F","","","X",
                "w","","","u","","\","","p","","E","","\","","c","","S",
                "F","","","","","H","","","","B","","","i","o","","",
                "A","","","","","T","","q","","d","","","","u","|","",
                "c","","","","","S","","","","e","","","","","","",
                "","o","\","","","w","O","","h","P","","","","L","R","",
                "n","h","","q","","","","","p","d","t","L","","","","P",
                "","f","","","","","k","x","","","","","","","r","x",
                "","G","","c","","","","t","[","","","","@","[","l","S",
                "","","","","`","H","","","c","","","f","D","","_","",
                "","^","p","","","","","","A","","}","","","E","0x1dEE","0x1dEF",
                "X","","","L","","","","","","O","Q","m","","","",""
            };
        private string[] kanjiTable1E = new string[]
            {
                "h","","","z","s","","","","","","U","","","m","","g",
                "","","","","","","","","","","","o","","","","",
                "","F","g","l","","","","","","","","S","f","","","",
                "","E","P","","","","","","G","_","","|","","","","",
                "","","\","{","","","","","s","","","","","","","",
                "`","a","w","x","k","q","d","g","l","o","b","s","u","r","","",
                "","","","","","","","","m","","","","","","","",
                "","","","","","","J","n","Z","^","","","","v","","",
                "","","","e","~","","","","","","","","","","","",
                "","C","","","C","S","`","Z","","","","","","","","",
                "","","","","c","","K","","","","E","a","","","C","b",
                "","","","^","S","_","n","w","","","","","","","z","u",
                "","e","f","n","","","","V","]","{","","","g","j","e","",
                "","","","K","S","","","@","","P","","","","","","",
                "","d","","","","","","","","","","","","","T","0x1eEF",
                "","","","","o","","Y","","0x1eF8","0x1eF9","0x1eFA","0x1eFB","0x1eFC","0x1eFD","0x1eFE","0x1eFF",
            };
        private string[] kanjiTable1F = new string[]
            {
                "","K","","","","q","","","X","","K","","","","","",
                "","","","","H","","","","","","","","","","","",
                "o","","r","","u","","x","","{","","K","","M","","O","",
                "Q","","S","","U","","W","","Y","","[","","]","","_","",
                "a","","d","","f","","h","","","p","","s","","v","","",
                "","|","","0","1","2","3","4","5","6","7","8","9","m","h","p",
                "n","","q","","t","","w","","z","","J","","L","","N","",
                "P","","R","","T","","V","","X","","Z","","\","","^","",
                "`","","c","","e","","g","","E","","A","","C","","G","",
                "I","","i","","j","","k","","l","","m","","}","","~","",
                "","","","","","","","","","","","","","","","",
                "","","","","","","","","","","","","b","","","",
                "","","","","@","[","B","c","D","I","F","H","H","A","^","F",
                "u","v","B","\","o","","","","","","a","v","J","s","I","",
                "","","]","","","","","","j","]","","","","","","",
                "`","","","","","Y","","Y","","","","B","","O","","0x1fFF",
            };

        private string[] comandNameArray = new string[]
            {
        "","ACe","܂ق","gX","ǂ","ʂ","Ԃǂ","Ђ","Ȃ",
        "","Ђ킴","܂ӂ","ڂ킴","XPb`","","Xbg",
        "΂","Ƃт","̂܂","ǂ","`FW","ڂ","Wv","񂼂","ɂȂ",
        "傤","̂","VbN","Ƃ","܂ǂ","Ȃ"
            };

        #endregion
        #region stringFunction
        /// <summary>
        /// oCif[^̃ItZbgʒu當f[^쐬ԂBIR[h0x00ƂȂ
        /// </summary>
        /// <param name="data">f[^</param>
        /// <param name="offset">f[^ǂݏoJnʒu</param>
        /// <returns>ϊ㕶</returns>
        public string GetString(byte[] data, int offset)
        {
            string str = "";
            while (data[offset] != 0)
            {
                switch (data[offset])
                {
                    case 0x1b:
                        offset++;
                        str += kanjiTable1B[data[offset++]];
                        break;
                    case 0x1c:
                        offset++;
                        str += kanjiTable1C[data[offset++]];
                        break;
                    case 0x1d:
                        offset++;
                        str += kanjiTable1D[data[offset++]];
                        break;
                    case 0x1e:
                        offset++;
                        str += kanjiTable1E[data[offset++]];
                        break;
                    case 0x1f:
                        offset++;
                        str += kanjiTable1F[data[offset++]];
                        break;
                    default:
                        str += nameTable[data[offset++]];
                        break;
                }
            }
            return str;
        }

        /// <summary>
        /// ϒ̃oCif[^̃ItZbgʒu當f[^쐬ԂB
        /// </summary>
        /// <param name="data">f[^</param>
        /// <param name="offset">f[^ǂݏoJnʒu</param>
        /// <param name="length">ǂݏooCg̒</param>
        /// <returns>ϊ㕶</returns>
        public string GetString(byte[] data, int offset, int length)
        {
            string str = "";
            int endOffset = offset + length;
            while (offset < endOffset)
            {
                if (data[offset] == 0xFF) break;
                if (data[offset] == 0x00) break;
                switch (data[offset])
                {
                    case 0x1b:
                        offset++;
                        str += kanjiTable1B[data[offset++]];
                        break;
                    case 0x1c:
                        offset++;
                        str += kanjiTable1C[data[offset++]];
                        break;
                    case 0x1d:
                        offset++;
                        str += kanjiTable1D[data[offset++]];
                        break;
                    case 0x1e:
                        offset++;
                        str += kanjiTable1E[data[offset++]];
                        break;
                    case 0x1f:
                        offset++;
                        str += kanjiTable1F[data[offset++]];
                        break;
                    default:
                        str += nameTable[data[offset++]];
                        break;
                }
            }
            return str;
        }

        /// <summary>
        /// w肳ꂽŁA^ꂽoCif[^̃ItZbgʒu當f[^쐬ԂB
        /// </summary>
        /// <param name="data">f[^</param>
        /// <param name="offset">f[^ǂݏoJnʒu</param>
        /// <param name="length">ǂݏooCg̒</param>
        /// <returns>ϊ㕶</returns>
        public string GetStringFixed(byte[] data, int offset, int length)
        {
            string str = "";
            int endOffset = offset + length;
            while (offset < endOffset)
            {
                switch (data[offset])
                {
                    case 0x1b:
                        offset++;
                        str += kanjiTable1B[data[offset++]];
                        break;
                    case 0x1c:
                        offset++;
                        str += kanjiTable1C[data[offset++]];
                        break;
                    case 0x1d:
                        offset++;
                        str += kanjiTable1D[data[offset++]];
                        break;
                    case 0x1e:
                        offset++;
                        str += kanjiTable1E[data[offset++]];
                        break;
                    case 0x1f:
                        offset++;
                        str += kanjiTable1F[data[offset++]];
                        break;
                    default:
                        str += nameTable[data[offset++]];
                        break;
                }
            }
            return str;
        }

        /// <summary>
        /// w肵oCg܂Őݒ肷֐
        /// </summary>
        /// <param name="data">ݒ肷f[^</param>
        /// <param name="offset">f[^ݒ肷ꏊ</param>
        /// <param name="str">ݒ肵̕</param>
        /// <param name="length">ݒ肷oCg</param>
        /// <param name="voidData">w肵oCgɓBȂꍇɖ߂bytef[^</param>
        public void SetString(byte[] data, int offset, string str, int bytelength, byte voidData)
        {
            byte[] temp = new byte[bytelength * 4];
            int tempPointer = 0;
            int endOffset = offset + bytelength;
            bool serch;
            string tempStr;

            for (int i = 0; i < str.Length && tempPointer < bytelength; i++)
            {
                serch = true;
                tempStr = str.Substring(i, 1);
                if (serch) for (int j = 0; j < nameTable.Length; j++)
                        if (nameTable[j][0] == tempStr[0])
                        {
                            if (nameTable[j] == tempStr)
                            {
                                temp[tempPointer++] = (byte)j;
                                serch = false;
                                break;
                            }
                            else
                            {
                                if (str.IndexOf(nameTable[j]) == i)
                                {
                                    temp[tempPointer++] = (byte)j;
                                    serch = false;
                                    i += nameTable[j].Length - 1;
                                    break;
                                }
                            }

                        }
                if (serch) for (int j = 0; j < kanjiTable1F.Length; j++)
                        if (kanjiTable1F[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1F;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1E.Length; j++)
                        if (kanjiTable1E[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1E;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1D.Length; j++)
                        if (kanjiTable1D[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1D;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1C.Length; j++)
                        if (kanjiTable1C[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1C;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1B.Length; j++)
                        if (kanjiTable1B[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1B;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }

            }
            while (tempPointer < bytelength) temp[tempPointer++] = voidData;
            Array.Copy(temp, 0, data, offset, bytelength);
        }

        /// <summary>
        /// R̕؂oCg܂Őݒ肷֐
        /// ŏIbyteɂ͕K1ȏvoidf[^ݒ肷
        /// </summary>
        /// <param name="data">Ώۃf[^</param>
        /// <param name="offset">ItZbgʒu</param>
        /// <param name="str">ݒ蕶</param>
        /// <param name="paddingLength">؂oCg</param>
        /// <param name="voidData">؂܂ł𖄂߂oCgf[^</param>
        /// <returns>ݒ肵oCg</returns>
        public int SetStringPadding(byte[] data, int offset, string str, int paddingLength, byte voidData)
        {
            byte[] temp = new byte[str.Length * 3 + 10];
            int tempPointer = 0;
            bool serch;
            string tempStr;
            int i;
            for (i = 0; i < str.Length; i++)
            {
                serch = true;
                tempStr = str.Substring(i, 1);
                if (serch) for (int j = 0; j < nameTable.Length; j++)
                        if (nameTable[j][0] == tempStr[0])
                        {
                            if (nameTable[j] == tempStr)
                            {
                                temp[tempPointer++] = (byte)j;
                                serch = false;
                                break;
                            }
                            else
                            {
                                if (str.IndexOf(nameTable[j]) == i)
                                {
                                    temp[tempPointer++] = (byte)j;
                                    serch = false;
                                    i += nameTable[j].Length - 1;
                                    break;
                                }
                            }

                        }
                if (serch) for (int j = 0; j < kanjiTable1F.Length; j++)
                        if (kanjiTable1F[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1F;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1E.Length; j++)
                        if (kanjiTable1E[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1E;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1D.Length; j++)
                        if (kanjiTable1D[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1D;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1C.Length; j++)
                        if (kanjiTable1C[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1C;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1B.Length; j++)
                        if (kanjiTable1B[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1B;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
            }
            do temp[tempPointer++] = voidData; while (tempPointer % paddingLength != 0x00);
            Array.Copy(temp, 0, data, offset, tempPointer);
            return tempPointer;
        }

        /// <summary>
        /// R̕ŏIbyteɂvoidf[^ݒ肷
        /// </summary>
        /// <param name="data">Ώۃf[^</param>
        /// <param name="offset">ItZbgʒu</param>
        /// <param name="str">ݒ蕶</param>
        /// <param name="voidData">ŏIoCgf[^</param>
        /// <returns>ݒ肵oCg</returns>
        public int SetString(byte[] data, int offset, string str, byte voidData)
        {
            byte[] temp = new byte[str.Length * 3 + 10];
            int tempPointer = 0;
            bool serch;
            string tempStr;
            int i;
            for (i = 0; i < str.Length; i++)
            {
                serch = true;
                tempStr = str.Substring(i, 1);
                if (serch) for (int j = 0; j < nameTable.Length; j++)
                        if (nameTable[j][0] == tempStr[0])
                        {
                            if (nameTable[j] == tempStr)
                            {
                                temp[tempPointer++] = (byte)j;
                                serch = false;
                                break;
                            }
                            else
                            {
                                if (str.IndexOf(nameTable[j]) == i)
                                {
                                    temp[tempPointer++] = (byte)j;
                                    serch = false;
                                    i += nameTable[j].Length - 1;
                                    break;
                                }
                            }

                        }
                if (serch) for (int j = 0; j < kanjiTable1F.Length; j++)
                        if (kanjiTable1F[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1F;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1E.Length; j++)
                        if (kanjiTable1E[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1E;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1D.Length; j++)
                        if (kanjiTable1D[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1D;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1C.Length; j++)
                        if (kanjiTable1C[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1C;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
                if (serch) for (int j = 0; j < kanjiTable1B.Length; j++)
                        if (kanjiTable1B[j] == tempStr)
                        {
                            temp[tempPointer++] = 0x1B;
                            temp[tempPointer++] = (byte)j;
                            serch = false;
                            break;
                        }
            }
            temp[tempPointer++] = voidData;
            Array.Copy(temp, 0, data, offset, tempPointer);
            return tempPointer;
        }

        #endregion



        private Program program; public Program Program { get { return this.program; } }
        private int checkSumAddress; public int CheckSumAddress { get { return (int)Properties.Settings.Default.CheckSumAddress; } set { checkSumAddress = value; } }
        private int gameCodeAddress; public int GameCodeAddress { get { return (int)Properties.Settings.Default.GameCodeAddress; } set { gameCodeAddress = value; } }
        private int gameCodeSize; public int GameCodeSize { get { return (int)Properties.Settings.Default.GameCodeSize; } set { gameCodeSize = value; } }


        private int tileTipPointer; public int TileTipPointer { get { return (int)Properties.Settings.Default.TileTipPointer; } set { tileTipPointer = value; } }
        private int tileTipArry; public int TileTipArry { get { return (int)Properties.Settings.Default.TileTipArry; } set { tileTipArry = value; } }

        private int paletteSetOffsetAddr; public int PaletteSetOffsetAddr { get { return (int)Properties.Settings.Default.PaletteSetOffsetAddr; } set { paletteSetOffsetAddr = value; } }
        private int paletteSetOffsetAddr2; public int PaletteSetOffsetAddr2 { get { return (int)Properties.Settings.Default.PaletteSetOffsetAddr2; } set { paletteSetOffsetAddr2 = value; } }

        private int layerOffsetAddr; public int LayerOffsetAddr { get { return (int)Properties.Settings.Default.LayerOffsetAddr; } set { layerOffsetAddr = value; } }
        private int battleZoneOffsetAddr; public int BattleZoneOffsetAddr { get { return (int)Properties.Settings.Default.BattleZoneOffsetAddr; } set { battleZoneOffsetAddr = value; } }


        private int npcLocationAddr; public int NpcLocationAddr { get { return (int)Properties.Settings.Default.NpcLocationAddr; } set { npcLocationAddr = value; } }
        private int npcLocationOffset; public int NpcLocationOffset { get { return (int)Properties.Settings.Default.NpcLocationOffset; } set { npcLocationOffset = value; } }
        private int npcCheakMemStartAddr; public int NpcCheakMemStartAddr { get { return (int)Properties.Settings.Default.NpcCheakMemStartAddr; } set { npcCheakMemStartAddr = value; } }
        private int npcCheakMemSize; public int NpcCheakMemSize { get { return (int)Properties.Settings.Default.NpcCheakMemSize; } set { npcCheakMemSize = value; } }
        private int npcEventPointerStartAddress; public int NpcEventPointerStartAddress { get { return (int)Properties.Settings.Default.NpcEventPointerStartAddress; } set { npcEventPointerStartAddress = value; } }
        private int npcEventPointerSize; public int NpcEventPointerSize { get { return (int)Properties.Settings.Default.NpcEventPointerSize; } set { npcEventPointerSize = value; } }
        private int npcSpecialOffset; public int NpcSpecialOffset { get { return (int)Properties.Settings.Default.NpcSpecialOffset; } set { npcSpecialOffset = value; } }
        private int npcPointerSize; public int NpcPointerSize { get { return (int)Properties.Settings.Default.NpcPointerSize; } set { npcPointerSize = value; } }

        private int npcSpritePointerOffset; public int NpcSpritePointerOffset { get { return (int)Properties.Settings.Default.NpcSpritePointerOffset; } set { npcSpritePointerOffset = value; } }
        private int npcSpriteBankOffset; public int NpcSpriteBankOffset { get { return (int)Properties.Settings.Default.NpcSpriteBankOffset; } set { npcSpriteBankOffset = value; } }
        private int npcSpriteSizeOffset; public int NpcSpriteSizeOffset { get { return (int)Properties.Settings.Default.NpcSpriteSizeOffset; } set { npcSpriteSizeOffset = value; } }

        private int treasureLocationAddr; public int TreasureLocationAddr { get { return (int)Properties.Settings.Default.TreasureLocationAddr; } set { treasureLocationAddr = value; } }
        private int treasureAddrOffset; public int TreasureAddrOffset { get { return (int)Properties.Settings.Default.TreasureAddrOffset; } set { treasureAddrOffset = value; } }
        private int treasureCheckMemStartAddr; public int TreasureCheckMemStartAddr { get { return (int)Properties.Settings.Default.TreasureCheckMemStartAddr; } set { treasureCheckMemStartAddr = value; } }
        private int treasureCheckMemSize; public int TreasureCheckMemSize { get { return (int)Properties.Settings.Default.TreasureCheckMemSize; } set { treasureCheckMemSize = value; } }
        private int treasurePointerAddr; public int TreasurePointerAddr { get { return (int)Properties.Settings.Default.TreasurePointerAddr; } set { treasurePointerAddr = value; } }
        private int treasurePointerSize; public int TreasurePointerSize { get { return (int)Properties.Settings.Default.TreasurePointerSize; } set { treasurePointerSize = value; } }

        private int entranceEventLocationAddr; public int EntranceEventLocationAddr { get { return (int)Properties.Settings.Default.EntranceEventLocationAddr; } set { entranceEventLocationAddr = value; } }
        private int eventLocationAddr; public int EventLocationAddr { get { return (int)Properties.Settings.Default.EventLocationAddr; } set { eventLocationAddr = value; } }
        private int eventLocationOffset; public int EventLocationOffset { get { return (int)Properties.Settings.Default.EventLocationOffset; } set { eventLocationOffset = value; } }
        private int eventPointerAddr; public int EventPointerAddr { get { return (int)Properties.Settings.Default.EventPointerAddr; } set { eventPointerAddr = value; } }
        private int eventPointerSize; public int EventPointerSize { get { return (int)Properties.Settings.Default.EventPointerSize; } set { eventPointerSize = value; } }

        private int exitShortLocationAddr; public int ExitShortLocationAddr { get { return (int)Properties.Settings.Default.ExitShortLocationAddr; } set { exitShortLocationAddr = value; } }
        private int exitsShortPointerSize; public int ExitsShortPointerSize { get { return (int)Properties.Settings.Default.ExitsShortPointerSize; } set { exitsShortPointerSize = value; } }
        private int exitLongLocationAddr; public int ExitLongLocationAddr { get { return (int)Properties.Settings.Default.ExitLongLocationAddr; } set { exitLongLocationAddr = value; } }
        private int exitsLongPointerSize; public int ExitsLongPointerSize { get { return (int)Properties.Settings.Default.ExitsLongPointerSize; } set { exitsLongPointerSize = value; } }
        private int exitShortSpecialOffset; public int ExitShortSpecialOffset { get { return (int)Properties.Settings.Default.ExitShortSpecialOffset; } set { exitShortSpecialOffset = value; } }
        private int exitShortStartOffset; public int ExitShortStartOffset { get { return (int)Properties.Settings.Default.ExitShortStartOffset; } set { exitShortStartOffset = value; } }
        private int exitLongStartOffset; public int ExitLongStartOffset { get { return (int)Properties.Settings.Default.ExitLongStartOffset; } set { exitLongStartOffset = value; } }


        //}bv֘A
        private int mapMesPointerAddr; public int MapMesPointerAddr { get { return (int)Properties.Settings.Default.MapMesPointerAddr; } set { mapMesPointerAddr = value; } }
        private int mapMesPointerSize; public int MapMesPointerSize { get { return (int)Properties.Settings.Default.MapMesPointerSize; } set { mapMesPointerSize = value; } }
        private int mapMesOffsetAddr; public int MapMesOffsetAddr { get { return (int)Properties.Settings.Default.MapMesOffsetAddr; } set { mapMesOffsetAddr = value; } }
        private int mapDataPointer; public int MapDataPointer { get { return (int)Properties.Settings.Default.MapDataPointer; } set { mapDataPointer = value; } }
        private int mapDataAddr; public int MapDataAddr { get { return (int)Properties.Settings.Default.MapDataAddr; } set { mapDataAddr = value; } }
        private int mapPropertyPointer; public int MapPropertyPointer { get { return (int)Properties.Settings.Default.MapPropertyPointer; } set { mapPropertyPointer = value; } }
        private int mapTilePropertyAddr; public int MapTilePropertyAddr { get { return (int)Properties.Settings.Default.MapTilePropertyAddr; } set { mapTilePropertyAddr = value; } }
        private int mapTilePropertySize; public int MapTilePropertySize { get { return (int)Properties.Settings.Default.MapTilePropertySize; } set { mapTilePropertySize = value; } }


        //L֌W
        private int charactersInitNameAddr; public int CharactersInitNameAddr { get { return charactersInitNameAddr; } set { charactersInitNameAddr = value; } }
        private int charactersInitDataAddr; public int CharactersInitDataAddr { get { return charactersInitDataAddr; } set { charactersInitDataAddr = value; } }
        private int charactersInitDataSize; public int CharactersInitDataSize { get { return charactersInitDataSize; } set { charactersInitDataSize = value; } }
        private int charactersComandNameAddr; public int CharactersComandNameAddr { get { return charactersComandNameAddr; } set { charactersComandNameAddr = value; } }


        //Item
        private int itemNameOffsetAddr; public int ItemNameOffsetAddr { get { return (int)Properties.Settings.Default.ItemNameOffsetAddr; } set { itemNameOffsetAddr = value; } }
        private int itemDataOffsetAddr; public int ItemDataOffsetAddr { get { return itemDataOffsetAddr; } set { itemDataOffsetAddr = value; } }
        private int itemStrPointerAddr; public int ItemStrPointerAddr { get { return itemStrPointerAddr; } set { itemStrPointerAddr = value; } }
        private int itemStrOffsetAddr; public int ItemStrOffsetAddr { get { return itemStrOffsetAddr; } set { itemStrOffsetAddr = value; } }

        private int itemAvoidCalculateCardinalNumber; public int ItemAvoidCalculateCardinalNumber { get { return itemAvoidCalculateCardinalNumber; } set { itemAvoidCalculateCardinalNumber = value; } }



        //size[byte]ŕ\L
        public ReaedRomSetting(Program program)
        {
            InitializeComponent();
            this.program = program;

            System.Collections.Specialized.StringCollection strs = Properties.Settings.Default.LevelNames;


            for (int i = 0; i < strs.Count; i++)
            {
                string[] temp = { strs[i], i.ToString()};
                listView1.Items.Add(new ListViewItem(temp));
                //textBox1.Text += strs[i];
            }

            //button2_Click(null, null);
        }
        public void TypeG()
        {

            //FF6-Gp
            Properties.Settings.Default.MapDataPointer = 0x297000;
            Properties.Settings.Default.MapPropertyPointer = 0x297600;
            Properties.Settings.Default.MapTilePropertySize = 0x29B0;
            Properties.Settings.Default.TileTipPointer = 0x2976A0;
            Properties.Settings.Default.TreasureLocationAddr = 0x2D82F4; //0x2D6400;
            Properties.Settings.Default.TreasureAddrOffset = 0x2D6400;
            itemStrOffsetAddr = 0x3B8000;//;//***G̃AhX͕sH`3BA7EF	2550	ACe
            Properties.Settings.Default.EventLocationAddr = 0x040000;//ivent|C^AhXOFFSET
            Properties.Settings.Default.EventLocationOffset = 0x180000;
            Properties.Settings.Default.EventPointerSize = 0x1A00;
            Properties.Settings.Default.NpcSpecialOffset = 0x041A10 - 0xF3000;
            Properties.Settings.Default.NpcPointerSize = 0x5B6E;
            Properties.Settings.Default.ExitsShortPointerSize = 0x2000;//
            Properties.Settings.Default.ExitShortSpecialOffset = 0x2977C2 - ExitShortLocationAddr - ExitShortStartOffset;
            //exitShortStartOffset = 0;

            Properties.Settings.Default.NpcSpritePointerOffset = 0x0F5900;
            Properties.Settings.Default.NpcSpriteBankOffset = 0x0F5B00;
            Properties.Settings.Default.NpcSpriteSizeOffset = 0x0F5B01;
            //levelUpExpAddr; 0x2d8220 2byte * 108
            //hpUpBounausAddr; 0x26f4a0 byte * 108
            //mpUpBounausAddr; 0x26f502 byte * 108
            //magicTina 0x2ce3c0 2byte *16
            //magicSeris 0x2ce3e0 2byte *16(@-LV)
            //magicName5 0x2d7400
            //magicName8 0x2d7400 + 5*0x36;
            itemAvoidCalculateCardinalNumber = 5;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            Properties.Settings.Default.CheckSumAddress = 0x06EC73;//us-rom 0x00FFDE

            Properties.Settings.Default.GameCodeAddress = 0xFFC0;//us-rom 0xFFB2
            Properties.Settings.Default.GameCodeSize = 0x14;


            //PaletteSetOffsetAddr
            Properties.Settings.Default.PaletteSetOffsetAddr = 0x2DC480;
            Properties.Settings.Default.PaletteSetOffsetAddr2 = 0x12EC00;//48*0x100zp̃AhX

            //Layer
            Properties.Settings.Default.LayerOffsetAddr = 0x2D8F00;
            Properties.Settings.Default.BattleZoneOffsetAddr = 0x0F5600;

            //0x041A10-0x041D51	NPCf[^ItZbg[size:2](+041A10) 
            //0x041D52-0x046A6B	NPCf[^ 
            Properties.Settings.Default.NpcLocationAddr = 0x0052C3;
            Properties.Settings.Default.NpcLocationOffset = 0xC00000;
            Properties.Settings.Default.NpcCheakMemStartAddr = 0x1EE0;//0x7E1EE0;
            Properties.Settings.Default.NpcCheakMemSize = 0x7F;//127;

            Properties.Settings.Default.NpcEventPointerStartAddress = 0x000A0000;
            Properties.Settings.Default.NpcEventPointerSize = 0x3FFFF;
            Properties.Settings.Default.NpcSpecialOffset = 0;//;//0x041D52;
            Properties.Settings.Default.NpcPointerSize = 2202 * 9;//0x041D52-0x46ABF 4D6A//5B6E

            Properties.Settings.Default.NpcSpritePointerOffset = 0x00D024;
            Properties.Settings.Default.NpcSpriteBankOffset = 0x00D16E;
            Properties.Settings.Default.NpcSpriteSizeOffset = 0x00D16F;



            //0x2D82F4-0x2D8633@󔠃f[^ItZbg[size:2] 
            //0x2D8634-0x2D8BC9@󔠃f[^ 
            Properties.Settings.Default.TreasureLocationAddr = 0x2D82F4;
            Properties.Settings.Default.TreasureAddrOffset = 0x2D8634;
            Properties.Settings.Default.TreasureCheckMemStartAddr = 0x1E40;//0x7E1E40;//0x1E40?
            Properties.Settings.Default.TreasureCheckMemSize = 0x3F;

            Properties.Settings.Default.TreasurePointerAddr = 0x2D8634;//0x041D52;
            Properties.Settings.Default.TreasurePointerSize = 417 * 5;//0x041D52-0x46ABF 4D6A

            //Cxg0x40342
            Properties.Settings.Default.EntranceEventLocationAddr = 0x11FA00;
            Properties.Settings.Default.EventLocationAddr = 0x040000;//ivent|C^AhXOFFSET
            Properties.Settings.Default.EventLocationOffset = 0x040000;// 0x180000;
            Properties.Settings.Default.EventPointerAddr = 0x40342;//gp
            Properties.Settings.Default.EventPointerSize = 0x16CE;

            //Exits0x1FB02
            Properties.Settings.Default.ExitShortLocationAddr = 0x1FBB00;//2977C2
            Properties.Settings.Default.ExitLongLocationAddr = 0x2DF480;
            Properties.Settings.Default.ExitsShortPointerSize = 0x1AFE;
            Properties.Settings.Default.ExitsLongPointerSize = 0x57E;
            Properties.Settings.Default.ExitShortSpecialOffset = 0;
            Properties.Settings.Default.ExitShortStartOffset = 0x0402;
            Properties.Settings.Default.ExitLongStartOffset = 0x0402;

            //MAP?
            //0x19F
            Properties.Settings.Default.MapMesPointerAddr = 0x268400;
            Properties.Settings.Default.MapMesOffsetAddr = 0x2684C0;
            Properties.Settings.Default.MapTilePropertyAddr = 0x19A800;
            Properties.Settings.Default.MapPropertyPointer = 0x19CD10;//mapvpeB
            Properties.Settings.Default.MapTilePropertySize = MapPropertyPointer - MapTilePropertyAddr;//0x19CD0F
            Properties.Settings.Default.MapDataPointer = 0x19CD90;//mapf[^|C^
            Properties.Settings.Default.MapDataAddr = 0x19D1B0;

            Properties.Settings.Default.TileTipPointer = 0x1FDA00;//^Cf[^
            Properties.Settings.Default.TileTipArry = 0x1FDB00;
            

            //Lf[^
            charactersInitNameAddr = 0x478C0;
            charactersInitDataAddr = 0x2D7CA0;
            charactersInitDataSize = 0x580;
            charactersComandNameAddr = 0x2CE300;

            //2CE300`2CE3BF	C0	R}h
            //2CE3C0`2CE3DF	20	eBiK@ƃx
            //2CE3E0`2CE3FF	20	ZXK@ƃx
            //2CE400`2CE7FF	400	UGtFNgf[^


            //2D0000`2D1CCF@	1CD0	EBhEOtBbN
            //2D1CD0`2D1CFF@	30	s
            //2D1D00`2D585F@	3B60	LOtBbN
            //2D5860`2D5ABF@	260	Lpbg
            //2D5AC0`2D627F@	7C0	ACROtBbN
            //2D6280`2D62FF@	80	s
            //2D6300`2D63FF@	100	LN^퓬pbg

            //2D7B50`2D7B5D	D	s
            //2D7B5E`2D7C9F	143	@
            //2D7CA0`2D821F	580	Lf[^
            //2D8220`2D82F3	D4	Kvol

            //LOtBbN 0x2D1D00 0x3B60
            //
            //Lpbg 0x2D5860

            //Item
            Properties.Settings.Default.ItemNameOffsetAddr = 0x26F701;//0x26F700 itemsize = 256
            itemDataOffsetAddr = 0x185000;//`186DFF	1E00	ACef[^
            itemStrPointerAddr = 0x186E00;//`186FFF	200	ACeItZbg
            itemStrOffsetAddr = 0x2D6400;//0x3B8000;//***G̃AhX͕sH`3BA7EF	2550	ACe

            itemAvoidCalculateCardinalNumber = 10;



        }

        private void button1_Click(object sender, EventArgs e)
        {
            System.Collections.Specialized.StringCollection strs = new System.Collections.Specialized.StringCollection();

            for (int i = 0; i < listView1.Items.Count; i++)
            {
                strs.Add(listView1.Items[i].SubItems[0].Text);
            }

            Properties.Settings.Default.LevelNames = strs;
            Properties.Settings.Default.Save();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            TypeG();
        }

        private void listView1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void ReaedRomSetting_Load(object sender, EventArgs e)
        {
            //ACe[U[ҏWł悤ɂ
            listView1.LabelEdit = true;

            //Cxgnh̒ǉ
            listView1.BeforeLabelEdit += new LabelEditEventHandler(ListView1_BeforeLabelEdit);
            listView1.AfterLabelEdit += new LabelEditEventHandler(ListView1_AfterLabelEdit);
            listView1.KeyUp += new KeyEventHandler(ListView1_KeyUp);
        }
        //ACẽx̕ҏWJnꂽ
        private void ListView1_BeforeLabelEdit(
            object sender, LabelEditEventArgs e)
        {

        }

        //ACẽx̕ҏWꂽ
        private void ListView1_AfterLabelEdit(
            object sender, LabelEditEventArgs e)
        {
            if (e.Label != null)
            {
                ListView lv = (ListView)sender;
                //̃ACe邩ׂ
                foreach (ListViewItem lvi in lv.Items)
                {
                    //̃ACeƂ͕ҏWLZ
                    if (lvi.Text == e.Label)
                    {
                        MessageBox.Show("̃ACełɂ܂B");
                        e.CancelEdit = true;
                        return;
                    }
                }
            }
        }

        //ListView1ŃL[ꂽ
        private void ListView1_KeyUp(object sender, KeyEventArgs e)
        {
            //F2L[ꂽƂ́AtH[JX̂ACe̕ҏWJn
            if (e.KeyCode == Keys.F2 && listView1.FocusedItem != null)
            {
                listView1.FocusedItem.BeginEdit();
            }

        }

        private void listView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            listView1.FocusedItem.BeginEdit();
        }
    }
}
